/** Copyright (C) 2017 by Bundesanstalt für Gewässerkunde
 * Software engineering by
 *  Björnsen Beratende Ingenieure GmbH
 *  Dr. Schumacher Ingenieurbüro für Wasser und Umwelt
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */
package org.dive4elements.river.client.client.ui;

import org.dive4elements.river.client.client.ui.DatacageTwinPanel.IDatacageTwinPanelInfo;
import org.dive4elements.river.client.shared.model.Recommendation;

/**
 * This info implementation overwrites the real factory of the recommendation with a fixed value.
 * Evil, but this is how it is done in the current code.
 *
 * @author Gernot Belger
 */
public final class DefaultDatacageTwinPanelInfo implements IDatacageTwinPanelInfo {

    private final String factory;
    private final String outs;
    private final String columnLabel;

    public DefaultDatacageTwinPanelInfo(final String columnLabel, final String factory, final String outs) {
        this.columnLabel = columnLabel;
        this.factory = factory;
        this.outs = outs;
    }

    @Override
    public String getFactory(final String originalFactory) {
        return this.factory;
    }

    @Override
    public String getDataStringFactory(final Recommendation recommendation) {
        return this.factory;
    }

    @Override
    public void adjustRecommendation(final Recommendation recommendation) {
        recommendation.setFactory(this.factory);
    }

    @Override
    public String getColumnLabel() {
        return this.columnLabel;
    }

    @Override
    public String getOuts() {
        return this.outs;
    }
}